#
# Initialization for pschedulerapiserver
#

import pscheduler

from flask import Flask

# This must happen before the other imports.
application = Flask(__name__)
application.config["APPLICATION_ROOT"] = pscheduler.api_root()

application.config["DEBUG"] = False

# These get done in this order to satisfy dependencies.

from .response import *
from .debug import *
from .log import *

from .access import *
from .admin import *
from .args import *
from .dbcursor import *
from .json import *
from .limitproc import *
from .limits import *
from .archivers import *
from .contexts import *
from .runs import *
from .schedule import *
from .stat import *
from .tasks import *
from .tests import *
from .tools import *
from .util import *


# These values are not hard-wired; they were filled in during the
# build.

dsn = "@/etc/pscheduler/database/database-dsn"
dbcursor_init(dsn)


limit_file = "/etc/pscheduler/limits.conf"
limitproc_init(limit_file)
